# tc_project_service

TcProjectService - JavaScript client for tc_project_service
Services that provide access and interaction with user projects.
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install tc_project_service --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/YOUR_USERNAME/tc_project_service
then install it via:

```shell
    npm install YOUR_USERNAME/tc_project_service --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var TcProjectService = require('tc_project_service');

var defaultClient = TcProjectService.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = "YOUR API KEY"
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix['Authorization'] = "Token"

var api = new TcProjectService.DefaultApi()

var body = new TcProjectService.ProjectRequestBody(); // {ProjectRequestBody} 


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.directProjectsPost(body, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://api.topcoder.com/v3*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*TcProjectService.DefaultApi* | [**directProjectsPost**](docs/DefaultApi.md#directProjectsPost) | **POST** /direct/projects | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdBillingaccountDelete**](docs/DefaultApi.md#directProjectsProjectIdBillingaccountDelete) | **DELETE** /direct/projects/{projectId}/billingaccount | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdBillingaccountPost**](docs/DefaultApi.md#directProjectsProjectIdBillingaccountPost) | **POST** /direct/projects/{projectId}/billingaccount | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdCopilotDelete**](docs/DefaultApi.md#directProjectsProjectIdCopilotDelete) | **DELETE** /direct/projects/{projectId}/copilot | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdCopilotPost**](docs/DefaultApi.md#directProjectsProjectIdCopilotPost) | **POST** /direct/projects/{projectId}/copilot | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdGet**](docs/DefaultApi.md#directProjectsProjectIdGet) | **GET** /direct/projects/{projectId} | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdMilestonesPost**](docs/DefaultApi.md#directProjectsProjectIdMilestonesPost) | **POST** /direct/projects/{projectId}/milestones | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdPermissionsDelete**](docs/DefaultApi.md#directProjectsProjectIdPermissionsDelete) | **DELETE** /direct/projects/{projectId}/permissions | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdPermissionsGet**](docs/DefaultApi.md#directProjectsProjectIdPermissionsGet) | **GET** /direct/projects/{projectId}/permissions | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdPermissionsPost**](docs/DefaultApi.md#directProjectsProjectIdPermissionsPost) | **POST** /direct/projects/{projectId}/permissions | 
*TcProjectService.DefaultApi* | [**directProjectsProjectIdPermissionsPut**](docs/DefaultApi.md#directProjectsProjectIdPermissionsPut) | **PUT** /direct/projects/{projectId}/permissions | 
*TcProjectService.DefaultApi* | [**directProjectsUserGet**](docs/DefaultApi.md#directProjectsUserGet) | **GET** /direct/projects/user | 


## Documentation for Models

 - [TcProjectService.AddMilestoneRequest](docs/AddMilestoneRequest.md)
 - [TcProjectService.AddMilestoneResponse](docs/AddMilestoneResponse.md)
 - [TcProjectService.AddMilestoneResult](docs/AddMilestoneResult.md)
 - [TcProjectService.BillingAccount](docs/BillingAccount.md)
 - [TcProjectService.BillingAccountBody](docs/BillingAccountBody.md)
 - [TcProjectService.BillingAccountPostResponse](docs/BillingAccountPostResponse.md)
 - [TcProjectService.BillingAccountPostResult](docs/BillingAccountPostResult.md)
 - [TcProjectService.CopilotDeleteResponse](docs/CopilotDeleteResponse.md)
 - [TcProjectService.CopilotDeleteResult](docs/CopilotDeleteResult.md)
 - [TcProjectService.CopilotPostContent](docs/CopilotPostContent.md)
 - [TcProjectService.CopilotPostResponse](docs/CopilotPostResponse.md)
 - [TcProjectService.CopilotPostResult](docs/CopilotPostResult.md)
 - [TcProjectService.CopilotRequestBody](docs/CopilotRequestBody.md)
 - [TcProjectService.DirectProjectType](docs/DirectProjectType.md)
 - [TcProjectService.GenericResponse](docs/GenericResponse.md)
 - [TcProjectService.GenericResult](docs/GenericResult.md)
 - [TcProjectService.OptionalAnswer](docs/OptionalAnswer.md)
 - [TcProjectService.Permission](docs/Permission.md)
 - [TcProjectService.PermissionInfo](docs/PermissionInfo.md)
 - [TcProjectService.PermissionPermissionType](docs/PermissionPermissionType.md)
 - [TcProjectService.PermissionsBody](docs/PermissionsBody.md)
 - [TcProjectService.ProjectAnswer](docs/ProjectAnswer.md)
 - [TcProjectService.ProjectGetContent](docs/ProjectGetContent.md)
 - [TcProjectService.ProjectGetContentProject](docs/ProjectGetContentProject.md)
 - [TcProjectService.ProjectGetResponse](docs/ProjectGetResponse.md)
 - [TcProjectService.ProjectGetResult](docs/ProjectGetResult.md)
 - [TcProjectService.ProjectPermissionsGetResponse](docs/ProjectPermissionsGetResponse.md)
 - [TcProjectService.ProjectPostContent](docs/ProjectPostContent.md)
 - [TcProjectService.ProjectPostResponse](docs/ProjectPostResponse.md)
 - [TcProjectService.ProjectPostResult](docs/ProjectPostResult.md)
 - [TcProjectService.ProjectQuestion](docs/ProjectQuestion.md)
 - [TcProjectService.ProjectQuestionOption](docs/ProjectQuestionOption.md)
 - [TcProjectService.ProjectRequestBody](docs/ProjectRequestBody.md)
 - [TcProjectService.UserProjectContent](docs/UserProjectContent.md)
 - [TcProjectService.UserProjectResult](docs/UserProjectResult.md)
 - [TcProjectService.UserProjectsGetResponse](docs/UserProjectsGetResponse.md)


## Documentation for Authorization


### bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

