/**
 * tc-project-service
 * Services that provide access and interaction with user projects.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PermissionInfo', 'model/ProjectGetContentProject'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PermissionInfo'), require('./ProjectGetContentProject'));
  } else {
    // Browser globals (root is window)
    if (!root.TcProjectService) {
      root.TcProjectService = {};
    }
    root.TcProjectService.ProjectGetContent = factory(root.TcProjectService.ApiClient, root.TcProjectService.PermissionInfo, root.TcProjectService.ProjectGetContentProject);
  }
}(this, function(ApiClient, PermissionInfo, ProjectGetContentProject) {
  'use strict';




  /**
   * The ProjectGetContent model module.
   * @module model/ProjectGetContent
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>ProjectGetContent</code>.
   * @alias module:model/ProjectGetContent
   * @class
   * @param project {module:model/ProjectGetContentProject} 
   * @param permissionInfo {module:model/PermissionInfo} 
   * @param statusLabel {String} 
   */
  var exports = function(project, permissionInfo, statusLabel) {
    var _this = this;

    _this['project'] = project;
    _this['permissionInfo'] = permissionInfo;

























    _this['statusLabel'] = statusLabel;
  };

  /**
   * Constructs a <code>ProjectGetContent</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectGetContent} obj Optional instance to populate.
   * @return {module:model/ProjectGetContent} The populated <code>ProjectGetContent</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('project')) {
        obj['project'] = ProjectGetContentProject.constructFromObject(data['project']);
      }
      if (data.hasOwnProperty('permissionInfo')) {
        obj['permissionInfo'] = PermissionInfo.constructFromObject(data['permissionInfo']);
      }
      if (data.hasOwnProperty('svn')) {
        obj['svn'] = ApiClient.convertToType(data['svn'], 'String');
      }
      if (data.hasOwnProperty('jira')) {
        obj['jira'] = ApiClient.convertToType(data['jira'], 'String');
      }
      if (data.hasOwnProperty('totalBudget')) {
        obj['totalBudget'] = ApiClient.convertToType(data['totalBudget'], 'Number');
      }
      if (data.hasOwnProperty('actualCost')) {
        obj['actualCost'] = ApiClient.convertToType(data['actualCost'], 'Number');
      }
      if (data.hasOwnProperty('projectedCost')) {
        obj['projectedCost'] = ApiClient.convertToType(data['projectedCost'], 'Number');
      }
      if (data.hasOwnProperty('plannedDuration')) {
        obj['plannedDuration'] = ApiClient.convertToType(data['plannedDuration'], 'Number');
      }
      if (data.hasOwnProperty('actualDuration')) {
        obj['actualDuration'] = ApiClient.convertToType(data['actualDuration'], 'Number');
      }
      if (data.hasOwnProperty('projectedDuration')) {
        obj['projectedDuration'] = ApiClient.convertToType(data['projectedDuration'], 'Number');
      }
      if (data.hasOwnProperty('billingAccountIds')) {
        obj['billingAccountIds'] = ApiClient.convertToType(data['billingAccountIds'], ['Number']);
      }
      if (data.hasOwnProperty('clientManagers')) {
        obj['clientManagers'] = ApiClient.convertToType(data['clientManagers'], ['Number']);
      }
      if (data.hasOwnProperty('topcoderManagers')) {
        obj['topcoderManagers'] = ApiClient.convertToType(data['topcoderManagers'], ['Number']);
      }
      if (data.hasOwnProperty('accountManagers')) {
        obj['accountManagers'] = ApiClient.convertToType(data['accountManagers'], ['Number']);
      }
      if (data.hasOwnProperty('appirioManager')) {
        obj['appirioManager'] = ApiClient.convertToType(data['appirioManager'], 'String');
      }
      if (data.hasOwnProperty('projectResourceEmails')) {
        obj['projectResourceEmails'] = ApiClient.convertToType(data['projectResourceEmails'], Object);
      }
      if (data.hasOwnProperty('clientManagersHandles')) {
        obj['clientManagersHandles'] = ApiClient.convertToType(data['clientManagersHandles'], Object);
      }
      if (data.hasOwnProperty('topcoderManagersHandles')) {
        obj['topcoderManagersHandles'] = ApiClient.convertToType(data['topcoderManagersHandles'], Object);
      }
      if (data.hasOwnProperty('accountManagersHandles')) {
        obj['accountManagersHandles'] = ApiClient.convertToType(data['accountManagersHandles'], Object);
      }
      if (data.hasOwnProperty('copilotHandles')) {
        obj['copilotHandles'] = ApiClient.convertToType(data['copilotHandles'], Object);
      }
      if (data.hasOwnProperty('businessImpactRating')) {
        obj['businessImpactRating'] = ApiClient.convertToType(data['businessImpactRating'], 'Number');
      }
      if (data.hasOwnProperty('riskLevelRating')) {
        obj['riskLevelRating'] = ApiClient.convertToType(data['riskLevelRating'], 'Number');
      }
      if (data.hasOwnProperty('costRating')) {
        obj['costRating'] = ApiClient.convertToType(data['costRating'], 'Number');
      }
      if (data.hasOwnProperty('difficultyRating')) {
        obj['difficultyRating'] = ApiClient.convertToType(data['difficultyRating'], 'Number');
      }
      if (data.hasOwnProperty('roiRating')) {
        obj['roiRating'] = ApiClient.convertToType(data['roiRating'], 'Number');
      }
      if (data.hasOwnProperty('additionalProjectInfo')) {
        obj['additionalProjectInfo'] = ApiClient.convertToType(data['additionalProjectInfo'], Object);
      }
      if (data.hasOwnProperty('canAccessPermissionEdit')) {
        obj['canAccessPermissionEdit'] = ApiClient.convertToType(data['canAccessPermissionEdit'], 'Boolean');
      }
      if (data.hasOwnProperty('statusLabel')) {
        obj['statusLabel'] = ApiClient.convertToType(data['statusLabel'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/ProjectGetContentProject} project
   */
  exports.prototype['project'] = undefined;
  /**
   * @member {module:model/PermissionInfo} permissionInfo
   */
  exports.prototype['permissionInfo'] = undefined;
  /**
   * @member {String} svn
   */
  exports.prototype['svn'] = undefined;
  /**
   * @member {String} jira
   */
  exports.prototype['jira'] = undefined;
  /**
   * @member {Number} totalBudget
   */
  exports.prototype['totalBudget'] = undefined;
  /**
   * @member {Number} actualCost
   */
  exports.prototype['actualCost'] = undefined;
  /**
   * @member {Number} projectedCost
   */
  exports.prototype['projectedCost'] = undefined;
  /**
   * @member {Number} plannedDuration
   */
  exports.prototype['plannedDuration'] = undefined;
  /**
   * @member {Number} actualDuration
   */
  exports.prototype['actualDuration'] = undefined;
  /**
   * @member {Number} projectedDuration
   */
  exports.prototype['projectedDuration'] = undefined;
  /**
   * @member {Array.<Number>} billingAccountIds
   */
  exports.prototype['billingAccountIds'] = undefined;
  /**
   * @member {Array.<Number>} clientManagers
   */
  exports.prototype['clientManagers'] = undefined;
  /**
   * @member {Array.<Number>} topcoderManagers
   */
  exports.prototype['topcoderManagers'] = undefined;
  /**
   * @member {Array.<Number>} accountManagers
   */
  exports.prototype['accountManagers'] = undefined;
  /**
   * @member {String} appirioManager
   */
  exports.prototype['appirioManager'] = undefined;
  /**
   * @member {Object} projectResourceEmails
   */
  exports.prototype['projectResourceEmails'] = undefined;
  /**
   * @member {Object} clientManagersHandles
   */
  exports.prototype['clientManagersHandles'] = undefined;
  /**
   * @member {Object} topcoderManagersHandles
   */
  exports.prototype['topcoderManagersHandles'] = undefined;
  /**
   * @member {Object} accountManagersHandles
   */
  exports.prototype['accountManagersHandles'] = undefined;
  /**
   * @member {Object} copilotHandles
   */
  exports.prototype['copilotHandles'] = undefined;
  /**
   * @member {Number} businessImpactRating
   */
  exports.prototype['businessImpactRating'] = undefined;
  /**
   * @member {Number} riskLevelRating
   */
  exports.prototype['riskLevelRating'] = undefined;
  /**
   * @member {Number} costRating
   */
  exports.prototype['costRating'] = undefined;
  /**
   * @member {Number} difficultyRating
   */
  exports.prototype['difficultyRating'] = undefined;
  /**
   * @member {Number} roiRating
   */
  exports.prototype['roiRating'] = undefined;
  /**
   * @member {Object} additionalProjectInfo
   */
  exports.prototype['additionalProjectInfo'] = undefined;
  /**
   * @member {Boolean} canAccessPermissionEdit
   */
  exports.prototype['canAccessPermissionEdit'] = undefined;
  /**
   * @member {String} statusLabel
   */
  exports.prototype['statusLabel'] = undefined;



  return exports;
}));


